// 32. Paraykite programa,kuri algebrine postfiksine iraika veia  prasta algebrin iraika.


program Postfix;

type
  TOperations = (opNone, opPlus, opMinus, opMultiply, opDivide);
  TNeedBrackets = array[TOperations, 0..1, TOperations] of boolean;

const
  Operations : array[opPlus..opDivide] of char = ('+', '-', '*', '/');

  NeedBrackets : TNeedBrackets = (
        (
                (false, false, false, false, false),
                (false, false, false, false, false)
        ),
        (
                (false, false, false, false, false),
                (false, false, false, false, false)
        ),
        (
                (false, false, false, false, false),
                (false, true, true, false, false)
        ),
        (
                (false, true, true, false, false),
                (false, true, true, false, false)
        ),
        (
                (false, true, true, false, false),
                (false, true, true, true, true)
        )
  );

type
  TElement = record
    IsOperator : boolean;
    Operation : TOperations;
    Str : string;
  end;
  PElement = ^TElement;

  TElementArray = array[0..255] of PElement;

function IsDigit(c : char) : boolean;
begin
  IsDigit := (ord(c) >= ord('0')) and (ord(c) <= ord('9'));
end;

function MakeElementArray(line : string; var arr : TElementArray;
        var len : integer) : boolean;
var
  i : integer;
  buf : string;
  element : PElement;
begin
  len := 0;
  i := 0;
  while i < length(line) do begin
    inc(i);

    while (line[i] = ' ') or (line[i] = ',') do begin
      inc(i);
      if i > length(line) then break;
    end;

    if i <= length(line) then begin
      buf := '';
      element := new(PElement);
      if IsDigit(line[i]) then begin
        while IsDigit(line[i]) do begin
          buf := buf + line[i];
          inc(i);
          if i > length(line) then break;
        end;
        element^.IsOperator := false;
        element^.Operation := opNone;
        element^.Str := buf;
        dec(i);
      end else begin
        element^.IsOperator := true;
        element^.Str := '';
        if (line[i] = '+') or (line[i] = '-') or (line[i] = '*') or
        (line[i] = '/') then begin
          case line[i] of
            '+': element^.Operation := opPlus;
            '-': element^.Operation := opMinus;
            '*': element^.Operation := opMultiply;
            '/': element^.Operation := opDivide;
          end;
        end else begin
          MakeElementArray := false;
          dispose(element);
          exit;
        end;
      end;
      arr[len] := element;
      inc(len);
    end;

  end;
  MakeElementArray := true;
end;

function MergeElements(var arr : TElementArray; len : integer) : integer;
var
  i, j : integer;
  count : integer;
begin
  i := 0;
  j := 0;
  count := 0;
  while i < len do begin
    if arr[i]^.IsOperator then begin
      if count >= 2 then begin
        j := j - 2;
        if NeedBrackets[arr[i]^.Operation][0][arr[j]^.Operation] then
          arr[j]^.Str := '(' + arr[j]^.Str + ')';
        if NeedBrackets[arr[i]^.Operation][1][arr[j+1]^.Operation] then
          arr[j+1]^.Str := '(' + arr[j+1]^.Str + ')';
        arr[i]^.IsOperator := false;
        arr[i]^.Str := arr[j]^.Str + Operations[arr[i]^.Operation] + arr[j+1]^.Str;
        dispose(arr[j]);
        dispose(arr[j+1]);
        arr[j] := arr[i];
        if j <> i then
          arr[i] := nil;
      end else begin
        arr[j] := arr[i];
        if j<> i then
          arr[i] := nil;
      end;
      count := 0;
    end else begin
      arr[j] := arr[i];
      if j <> i then
        arr[i] := nil;
      inc(count);
    end;
    inc(i);
    inc(j);
  end;
  MergeElements := j;
end;

procedure FreeElements(var arr : TElementArray; len : integer);
var
  i : integer;
begin
  for i := 0 to len-1 do
    Dispose(arr[i]);
end;

var
  line : string;
  elements : TElementArray;
  i, len, newlen : integer;
begin
  writeln('Iveskite algebrine israiska postfiksine forma');
  readln(line);
  if not MakeElementArray(line, elements, newlen) then begin
    writeln('Ivedimo klaida');
    exit;
  end;
  repeat
    len := newlen;
    newlen := MergeElements(elements, len);
  until len = newlen;
  writeln('rezultatu skaicius: ', newlen);
  for i := 0 to newlen-1 do
    if elements[i]^.IsOperator then
      writeln(Operations[elements[i]^.Operation])
    else
      writeln(elements[i]^.Str);
  FreeElements(elements, newlen);
  readln;
end.
